import NeverData
import math

class Creature(NeverData.NeverData):
    propList = {
        'Appearance_Type':'2daIndex,appearance.2da,STRING_REF,strref,LABEL',
        'BodyBag':'2daIndex,bodybag.2da,Name,strref,Label',
        'Cha': 'Integer,0-50',
#        'ChallengeRating': 'Integer,0-50', ###This is actually a float
        'Con': 'Integer,0-50',
        'Conversation': 'ResRef,NSS',
        'CRAdjust': 'Integer,0-30',
        'CurrentHitPoints': 'Integer,0-1000',
        'Description': 'CExoLocString,4',
        'Dex': 'Integer,0-50',
        'Disarmable': 'Boolean',
        'FactionID': 'Integer,0-1000',
        'FirstName': 'CExoLocString',
        'fortbonus': 'Integer,0-20',
        'Gender': '2daIndex,gender.2da,NAME,strref',
        'GoodEvil': 'Integer, 0-100',
        'HitPoints': 'Integer,0-1000',
        'Int': 'Integer,0-50',
        'Interruptable': 'Boolean',
#        'IsImmortal': 'Boolean',   ### looks like it's only in saved game instances
        'IsPC': 'Boolean',
        'LastName': 'CExoLocString',
        'LawfulChaotic': 'Integer,0-100',
#        'Lootable': 'Boolean',,    ### again, only in saved game instances
        'MaxHitPoints': 'Integer,0-1000',
        'NaturalAC': 'Integer,0-50',
        'NoPermDeath': 'Boolean',
        'PerceptionRange': '2daIndex,ranges.2da,Name,strref,Label',        
        'Plot': 'Boolean',
        'Race': '2daIndex,racialtypes.2da,Name,strref,Label',
        'ScriptAttacked': 'ResRef,NSS',
        'ScriptDamaged': 'ResRef,NSS',
        'ScriptDeath': 'ResRef,NSS',
        'ScriptDialogue': 'ResRef,NSS',
        'ScriptDisturbed': 'ResRef,NSS',
        'ScriptEndRound': 'ResRef,NSS',
        'ScriptHeartbeat': 'ResRef,NSS',
        'ScriptOnBlocked': 'ResRef,NSS',
        'ScriptOnNotice': 'ResRef,NSS',
        'ScriptRested': 'ResRef,NSS',
        'ScriptSpawn': 'ResRef,NSS',
        'ScriptSpellAt': 'ResRef,NSS',
        'ScriptUserDefine': 'ResRef,NSS',
        'SoundSetFile': '2daIndex,soundset.2da,STRREF,strref,LABEL',
#        'StartingPackage': '2daIndex,packages.2da,Name,strref,Label', ### missing
        'Str': 'Integer,0-50',
        'Subrace': 'CExoString',
        'Tail': '2daIndex,tailmodel.2da,LABEL,string',
        'Tag': 'CExoString',
        'WalkRate': '2daIndex,creaturespeed.2da,Name,strref,Label',
        'willbonus': 'Integer,0-30',
        'Wings': '2daIndex,wingmodel.2da,LABEL,string',
        }
            
    def __init__(self,gffEntry):
        NeverData.NeverData.__init__(self)
        self.addPropList('main',self.propList,gffEntry)

    def getName(self):
        return self.gffstructDict['main'].getInterpretedEntry('FirstName').getString() + ' ' \
             + self.gffstructDict['main'].getInterpretedEntry('LastName').getString()
    
    def getX(self):
        return self.gffstructDict['main'].getInterpretedEntry('XPosition')

    def getY(self):
        return self.gffstructDict['main'].getInterpretedEntry('YPosition')

    def getZ(self):
        return self.gffstructDict['main'].getInterpretedEntry('ZPosition')

    def setX(self,x):
        self.gffstructDict['main'].setInterpretedEntry('XPosition',x)

    def setY(self,y):
        self.gffstructDict['main'].setInterpretedEntry('YPosition',y)

    def setZ(self,z):
        self.gffstructDict['main'].setInterpretedEntry('ZPosition',z)

    def getBearing(self):        
        return math.asin(self.getYOrientation())*180.0/math.pi
        
    def getXOrientation(self):
        return self.gffstructDict['main'].getInterpretedEntry('XOrientation')

    def getYOrientation(self):
        return self.gffstructDict['main'].getInterpretedEntry('XOrientation')

    def getObjectId(self):
        return self.gffstructDict['main'].getInterpretedEntry('ObjectId')

    
