from NeverData import NeverData
import os,os.path

compilerCommand = 'nwnnsscomp'

class Script(NeverData):
    def __init__(self,n,data):
        NeverData.__init__(self)
        self.name = n
        self.scriptData = data
        self.nwndir = None
        
    def getProperty(self,label):
        if label != self.name:
            print 'error, script contains',self.name,'not',label
        else:
            return [self.name,self.scriptData,'Script']

    def setProperty(self,label,value):
        if label != self.name:
            print 'error, script contains',self.name,'not',label
        else:
            self.scriptData = value
#            self.compile()
            
    def iterateProperties(self):
        yield [self.name,self.scriptData,'Script']

    def toFile(self,f,o):
        f.seek(o)
        f.write(self.scriptData)

    def setNWNDir(self,nwndir):
        self.nwndir = nwndir
        
    def compile(self):
        if not self.nwndir:
            print 'cannot compile script without location of NWN dir'
        tmp = os.tmpnam() #I know, warnings, it'd be nice to do this in mem eventually
        tmpf = open(tmp + '.nss','w')
        tmpf.write(self.scriptData)
        tmpf.close()
        command = compilerCommand + ' ' + '"' + self.nwndir + '"' + ' ' + tmp
        print 'executing: ' + command
        os.system(command) #compiler returns 0 in many cases, so check if it actually produced a file
        if os.path.exists(tmp + '.nsc'):
            nscFile = open(tmp + '.nsc')
            self.compiledData = nscFile.read()
            nscFile.close()
            os.remove(tmp + '.nsc')
        else:
            print 'script compile failed'
        os.remove(tmp + '.nss')

    def __str__(self):
        return self.scriptData

    def __repr__(self):
        return self.__str__()
